# ==================================================================
# Plugins::DownloadHitCounter - Auto Generated Program Module
#
#   Plugins::DownloadHitCounter
#   Author  : Philip Putnam
#   Version : 1.0
#   Updated : Tue Aug 22 01:22:33 2006
#
# ==================================================================
#

package Plugins::DownloadHitCounter;
# ==================================================================

use strict;
use GT::Base;
use GT::Plugins qw/STOP CONTINUE/;
use Links qw/:objects/;

# Inherit from base class for debug and error methods
@Plugins::DownloadHitCounter::ISA = qw(GT::Base);

# Your code begins here.


# PLUGIN HOOKS
# ===================================================================


sub handle_jump {
# -----------------------------------------------------------------------------
# This subroutine will be called whenever the hook 'handle_jump' is run.  You
# should call $PLG->action(STOP) if you don't want the regular
# 'handle_jump' code to run, otherwise the code will continue as normal.
#
    my $res   = shift;
    my $col   = $IN->param('v') || $IN->param('dl') || $IN->param('view') || $IN->param('download');
    my $links = $DB->table('Links');
    my $id    = $IN->param('ID');

    if ($col && $res) {
        my $clicktrack = $DB->table('ClickTrack');
        my $rows = $clicktrack->count({ LinkID => $id, IP => $ENV{REMOTE_ADDR}, ClickType => 'Hits' });
        unless ($rows) {
            eval {
                $clicktrack->insert({ LinkID => $id, IP => $ENV{REMOTE_ADDR}, ClickType => 'Hits', Created => \"NOW()" });
                $links->update({ Hits => \"Hits + 1" }, { ID => $id }, { GT_SQL_SKIP_INDEX => 1 });
            };
        }
    }

    return $res;
}

# Always end with a 1.
1;
